<?php

/************************************************************************************/
/*                                                                                  */
/* SiteMail                                                                         */
/* v1.2                                                                             */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
/* http://mat.allfreetemplates.com                                                  */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

$index = 0;
$module_name = basename( dirname( __FILE__ ) );

include( "modules/$module_name/gui.php" );       // Graphical User Interface SiteMail + Actions
include( "modules/$module_name/generic.php" );   // Generic routines for all scripts

if( !IsSet( $mainfile ) )
{ 
   include ( "mainfile.php" );
}

/******************************************************************************/
/* FUNCTION: SiteMailIndex()                                                  */
/* Main Start function for SiteMail                                           */
/******************************************************************************/
function SiteMailIndex()
{
   global $prefix, $user, $admin, $sitename, $cookie, $dbi, $user_prefix;
   include( "header.php" );
   
   OpenTable();
   $no_addresses = 0;
   $error_nbr = 0;

   // Get User name
   cookiedecode( $user );
   $username = $cookie[1];

   if( is_user( $user ) )
   {
      // Check if User already exists in nuke_sitemail_users dbase table
      $result = sql_query("select uname, name, email, url, user_from, mail_counter, mail_format from ".$user_prefix."_sitemail_users where uname='$username'", $dbi );
      if( sql_num_rows( $result ) == 0 )
      {
         // User does not exist, copy information from nuke_users to nuke_sitemail_users
         $result = sql_query( "select uname, name, email, url, user_from from ".$user_prefix."_users where uname='$username'", $dbi );
         $userinfo = sql_fetch_array( $result, $dbi );
         // in case location has no .gif extension, first remove it (when present) than add it (difference between phpBB2 and other Forums)
         $userinfo[ user_from ] = basename( $userinfo[ user_from ], ".gif" ) . ".gif";
         $result = sql_query( "insert into $user_prefix"._sitemail_users."( uname, name, email, url, user_from, mail_counter, mail_format ) values ( '$userinfo[uname]', '$userinfo[name]', '$userinfo[email]', '$userinfo[url]', '$userinfo[user_from]', '0', '1' )", $dbi );
         if ( !$result )
         {
           $error_message = _MSM_USERINSERTERROR;
           $error_nbr = 1;
         }
      }
   }
   else if( is_admin( $admin ) )
   {
      // Check if Admin already exists in nuke_sitemail_users dbase table
      $result = sql_query("select uname, name, email, url, user_from, mail_counter, mail_format from ".$user_prefix."_sitemail_users where uname='Admin'", $dbi );
      if( sql_num_rows( $result ) == 0 )
      {
         // Admin does not exist, copy information from nuke_users to nuke_sitemail_users
         $result = sql_query( "insert into $user_prefix"._sitemail_users."( uname, name, email, url, user_from, mail_counter, mail_format ) values ( 'Admin', 'Admin', 'Admin@localhost.com', 'http://', 'local', '0', '1' )", $dbi );
         if ( !$result )
         {
           $error_message = _MSM_ADMININSERTERROR;
           $error_nbr = 1;           
         }
      }
      $username = "Admin";
   }
   else  // User is anonymous
   {
      $error_message = _MSM_ANONMAIL;
      $error_nbr = 1;	    
   }

   if( $error_nbr == 0 )
   {
      // Set some variables
      $result = sql_query( "select uname, name, email, url, user_from, mail_counter, mail_format, mail_save, mail_priority from ".$user_prefix."_sitemail_users where uname='$username'", $dbi );
      $userinfo = sql_fetch_array( $result, $dbi );
      $from_email = $userinfo[ email ];
      $mail_counter = $userinfo[ mail_counter ];
      $welcome_user = $userinfo[ uname ];
      
      // Check if User already defined some E-mail addresses
      $result = sql_query( "select uname, email, first, last from ".$user_prefix."_sitemail_email where uname='$username'", $dbi );
      if( sql_num_rows( $result ) == 0 )
      {
         $no_addresses = 1; // No E-mail addresses yet defined
      
      }

      // Print the Site User Interface to Screen
      PlotSiteMailHeader( $no_addresses, $welcome_user, $mail_counter );
      PlotGUI( $from_email, $username );
      CloseTable();
      PlotSiteMailFooter( );
 
      include( "footer.php" );
   }
   else
   {
      // Print the Error-Message
      echo "<h4 align=center><b>$error_message</b>\n";
      CloseTable();
      PlotSiteMailFooter( );
      include("footer.php");
   }
} // END function SiteMailIndex()

/******************************************************************************/
/* FUNCTION: PlotSiteMailHeader()                                             */
/* Print the SiteHeader                                                       */
/******************************************************************************/
function PlotSiteMailHeader( $no_addresses, $welcome_user, $mail_counter )
{
   echo "<h2 align=center><b>"._MSM_WELCOME."$welcome_user</b><br>\n";
   echo "<h6 align=center>["._MSM_SENDMAILS1."$mail_counter "._MSM_SENDMAILS2."]<br>\n";
   if( $no_addresses == 1 ) echo "<h4 align=center><b>"._MSM_NOEMAILINBOX."</b>\n";
}

/******************************************************************************/
/* FUNCTION: PlotSiteMailFooter()                                             */
/* Print the SiteFooter                                                       */
/******************************************************************************/
function PlotSiteMailFooter()
{
   global $dbi, $user_prefix;
  
   echo "<br>";
   OpenTable();
   
   // Read Version Number
   $result = sql_query( "select Copyright, SMVersion from ".$user_prefix."_sitemail_cnf where uid='1'", $dbi );
   list( $Copyright, $SMVersion ) = sql_fetch_row( $result, $dbi );
   
   echo "<center><font class=\"tiny\"><font color=\"#000000\">".$SMVersion." "._BY." <a href=\"http://mat.allfreetemplates.com\">".$Copyright."</a>.</font></center>\n";
   CloseTable();
} // END function PlotSiteMailFooter()

/***************************************************/
/****************** PROGRAM START ******************/
/***************************************************/
switch ( $op )
{
    case "SiteMailIndex":
       SiteMailIndex();
    break;
    
    case "PlotSiteMailHeader":
       PlotSiteMailHeader( $no_addresses, $welcome_user, $mail_counter );
    break;

    case "PlotSiteMailFooter":
       PlotSiteMailFooter();
    break;

    case "PlotGUI":
       PlotGUI( $from_email, $username );
    break;
    
    default:
	SiteMailIndex();
}


?>

