<?php

/************************************************************************************/
/*                                                                                  */
/* SiteMail                                                                         */
/* v1.2                                                                             */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
/* http://mat.allfreetemplates.com                                                  */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

$module_name = basename( dirname( __FILE__ ) );
include( "modules/$module_name/generic.php" );   // Generic routines for all scripts
require_once("mainfile.php");

/******************************************************************************/
/* FUNCTION: CheckData()                                                      */
/* Check the entered data entered in the mail form                            */
/******************************************************************************/
function CheckData( $from_email, $to_email, $cc_email, $bcc_email, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $username )
{
   include( "header.php" );   
   
   OpenTable();

   $DataOK = 1;
   if ( $from_email == "" )
   {
      $from_err = "<p><center><font color=red>"._MSM_ERRORFROM."</font></center><br>";
      $DataOK = 0;
   }
   if ( $to_email[0] == "" )
   {
      $to_err = "<p><center><font color=red>"._MSM_ERRORTO."</font></center><br>";
      $DataOK = 0;
   }
   if ( $subject_email == "" )
   {
      $subject_err = "<p><center><font color=red>"._MSM_ERRORSUBJECT."</font></center><br>";
      $DataOK = 0;
   }
   if ( $message_email == "" )
   {
      $message_err = "<p><center><font color=red>"._MSM_ERRORMESSAGE."</font></center><br>";
      $DataOK = 0;
   }

   if ( $DataOK == 0 )
   {
      echo "<h2 align=center><font color=red><b>"._MSM_ERRORDATA."</font></h2></b><br>\n";
      echo "$from_err";
      echo "$to_err";
      echo "$subject_err";
      echo "$message_err";
      echo "<center>[ <a href=\"javascript:history.go( -1 )\">"._MSM_GOBACK."</a> ]</center>";
      CloseTable();
   }
   else
   {
      // It's ok to send the E-mail, all fields are filled out
      // Extract now the selected E-mail addresses
      $to = ExtractTOAddresses( $to_email, $username );
      $cc = ExtractCCAddresses( $cc_email, $username );
      if( $cc == "" ) { $cc_exists = 0; } else { $cc_exists = 1; }
      $bcc = ExtractBCCAddresses( $bcc_email, $username );      
      if( $bcc == "" ) { $bcc_exists = 0; } else { $bcc_exists = 1; }

      SendEmail( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $cc_exists, $bcc_exists, $username );
   }
   
   CloseTable();
   include( "footer.php" );
}

/******************************************************************************/
/* FUNCTION: SendEmail()                                                      */
/* Send the E-mail                                                            */
/******************************************************************************/
function SendEmail( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $cc_exists, $bcc_exists, $username )
{
   global $dbi, $user_prefix, $module_name;

   include( "modules/$module_name/include/htmlMimeMail.php" );   

   // Get some Admin configuration Settings
   $result = sql_query( "select mail_method, allow_attach, upload_dir, max_att_size, smtp_host, smtp_port from ".$user_prefix."_sitemail_cnf where uid='1'", $dbi );
   list( $mail_method, $allow_attach, $upload_dir, $max_att_size, $smtp_host, $smtp_port ) = sql_fetch_row( $result, $dbi );
 
   // Create Mail Object: HTML Mime mail class scripts of Richard Heyes (http://www.phpguru.org)
   $mail = new htmlMimeMail();
   
   $mail->setSubject( $subject_email );
   $mail->setFrom( $from_email );
   $mail->setReturnPath( $from_email );
   $mail->setHeader('X-Priority', $mail_priority );   
   
   if( $cc_exists == 1 ) { $mail->setCc( $cc ); }
   if( $bcc_exists == 1 ) { $mail->setBcc( $bcc ); }   

   // mail_format = 0: Send E-mail as HTML -- = 1: Send as Text
   if( $mail_format == 0 )
   { 
      $mail->setHtml( $message_email, '' );
      //$background = $mail->getFile( "modules/$module_name/include/logo.gif" );
      //$mail->addHtmlImage( $background, 'logo.gif', 'image/gif' );        
   }
   else
   {
      $mail->setText( $message_email );   	
   }

   // Attachment should be sent as well
   if( $allow_attach == 1 )
   {
      $attached_file = UploadAttachment( $max_att_size, $upload_dir );
      if( $attached_file == "" )
      {
         $attachment_sent = 0;
      }
      else
      {
         $attachment_sent = 1;
         $attachment = $mail->getFile( $attached_file );
         $mail->addAttachment( $attachment, basename( $attached_file ), 'application/octet-stream' );         
      }
   }
  
   // mail_method = 0: Normal mail() -- = 1: Use SMTP
   if( $mail_method == 0 )
   {
      $result = $mail->send( array( $to ) );
   }
   else
   {
      $mail->setSMTPParams( $smtp_host, $smtp_port );
      $result = $mail->send( array( $to ), 'smtp' );
   }
   
   if( $result )
   {
      // Mail sent succesfully
      UpdateUserSettings( $username, $mail_format, $mail_save, $mail_priority, $attachment_sent, $attached_file );
      echo "\n<h3 align=center><font color=black><b>"._MSM_MAILSEND."</b></font></h3>\n";
      
      // Store E-mail if set to Mail_Save = Yes
      if( $mail_save == 1 )
      { 
         // Get Max_Store parameter from Admin Config Settings
         $result = sql_query( "select max_store from ".$user_prefix."_sitemail_cnf where uid='1'", $dbi );
         list( $max_store ) = sql_fetch_row( $result, $dbi );
         // Determine how many E-mails already present in SentBox
         $result = sql_query( "select * from ".$user_prefix."_sitemail_sentbox where uname='$username'", $dbi );
         $instore = sql_num_rows( $result );
         
	 if( $instore < $max_store )
	 { 	      
            StoreInSentBox( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $username );
         }
         else
         {
            echo "\n<h4 align=center><font color=blue><br><b>"._MSM_WARNINGSENTNOTSTORED."</b></font></h4>\n";          		 
         }
      }
   }
   else
   {
      // Mail could not be sent
      echo "\n<h3 align=center><font color=red><b>"._MSM_ERRORMAILNOTSEND."</b></font></h3>\n";
   }    

   echo "<p><center>[ <a href=\"modules.php?name=$module_name\">"._MSM_GOBACK."</a> ]</center>";   
}

/******************************************************************************/
/* FUNCTION: UpdateUserSettings                                               */
/* Update for user the amount of sent E-mails, mail_format and mail_save      */
/******************************************************************************/
function UpdateUserSettings( $username, $mail_format, $mail_save, $mail_priority, $attachment_sent, $attached_file )
{
   global $user, $dbi, $user_prefix;
    
   $result = sql_query( "select mail_counter, attach_counter, attach_size_counter from ".$user_prefix."_sitemail_users where uname='$username'", $dbi );
   list( $mail_counter, $attach_counter, $attach_size_counter ) = sql_fetch_row( $result, $dbi );
   $mail_counter += 1;

   if( $attachment_sent == 1 )
   {
      $attach_counter += 1;
      $attach_size_counter += filesize( $attached_file );
      $query="update ".$user_prefix."_sitemail_users set mail_counter='$mail_counter', attach_counter='$attach_counter', attach_size_counter='$attach_size_counter', mail_format='$mail_format', mail_save='$mail_save', mail_priority='$mail_priority' where uname='$username'";
   }
   else
   {
      $query="update ".$user_prefix."_sitemail_users set mail_counter='$mail_counter', mail_format='$mail_format', mail_save='$mail_save', mail_priority='$mail_priority' where uname='$username'";
   }
   $result = sql_query( $query, $dbi );
   if ( !$result )
   {
       echo ""._MSM_ERRORUSERUPDATE."";
   }
}

/******************************************************************************/
/* FUNCTION: StoreInSentBox                                                   */
/* Write E-mail to SentBox                                                    */
/******************************************************************************/
function StoreInSentBox( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $username )
{
   global $user, $dbi, $user_prefix;

   $result = sql_query( "select max(uid) as latest_uid from $user_prefix"._sitemail_sentbox."", $dbi );
   list( $latest_uid ) = sql_fetch_array( $result, $dbi );
   if ( $latest_uid == "-1")
   {
      $latest_uid = 1;
   }
   else
   {
      $latest_uid += 1;
   }

   $timestamp = date("d-m-Y G-i");
   $result = sql_query( "insert into $user_prefix"._sitemail_sentbox." ( uid, uname, from_email, to_email, cc_email, bcc_email, subject_email, message_email, timestamp ) values (  '$latest_uid', '$username', '$from_email', '$to', '$cc', '$bcc', '$subject_email', '$message_email', '$timestamp' )", $dbi );
   if ( !$result )
   {
       echo ""._MSM_ERRORSENTSTORAGE."";
   }      
}

/******************************************************************************/
/* FUNCTION: UploadAttachment                                                 */
/* Copy the attachment from Client-system to Server                           */
/******************************************************************************/
function UploadAttachment( $max_att_size, $upload_dir )
{
   if( is_uploaded_file( $_FILES['userfile']['tmp_name'] ) )
   {
      if( filesize( $_FILES['userfile']['tmp_name'] ) > $max_att_size )
      {
         echo "\n<h4 align=center><font color=blue><br><b>"._MSM_WARNINGSENTATTACHMENT1."</b></font></h4>\n";
         return( "" );
      }
      else
      {
         $filename = $_FILES['userfile']['tmp_name'];
         $realname = $_FILES['userfile']['name'];

         if( copy( $_FILES['userfile']['tmp_name'], $upload_dir.$realname ) )
         {
            return( $upload_dir.$realname );         	
         }
         else
         {
            echo "\n<h4 align=center><font color=blue><br><b>"._MSM_WARNINGSENTATTACHMENT2."</b></font></h4>\n";
            return( "" );
         }
      }
   }
   else
   {
      //echo "\n<h4 align=center><font color=blue><br><b>"._MSM_WARNINGSENTATTACHMENT2."</b></font></h4>\n";
      return( "" );
   }
}

/******************************************************************************/
/* FUNCTION: ExtractTOAddresses                                               */
/* Get the TO Email addresses and Generate TO Line                            */
/******************************************************************************/
function ExtractTOAddresses( $to_email, $username )
{
   global $dbi, $user_prefix;

   // Get the TO Email addresses and Generate TO Line
   $to = "";
   
   for( $i = 0; $i < count( $to_email ); $i++ )
   {
      // First check if name is a group name	
      $pos = strpos( $to_email[ $i ], "E-mail Group" );
      if( $pos === false )
      {
         // Normal E-mail address
         $to_email[ $i ] = substr( $to_email[ $i ], 0, strpos( $to_email[ $i ], ">" ) - 1 );
         $to .= $to_email[ $i ].",";
      }
      else
      {
         // E-mail Group
         $to_email[ $i ] = substr( $to_email[ $i ], 0, strpos( $to_email[ $i ], ">" ) - 1 );
         // Grep E-mail addresses belonging to this group
         $result = sql_query( "select email, gname from ".$user_prefix."_sitemail_email where uname='$username'", $dbi );
         while( list( $email, $gname ) = sql_fetch_row( $result, $dbi ) )
         {
            $Egname = explode( ",", $gname );
            if( in_array( $to_email[ $i ], $Egname ) ) { $to .= $email.","; }
         }
      }
   }

   // $to = rtrim( $to, "," );
   // The second parameter was added in PHP 4.1.0. This doesn't work on older PHP versions
   // !! WORKAROUND !!
   $to = rtrim( $to );
   $to = substr( $to, 0, strlen( $to ) - 1 ); // returns complete string without last character ','
   return( $to );
}

/******************************************************************************/
/* FUNCTION: ExtractCCAddresses                                               */
/* Get the CC Email addresses and Generate CC Line                            */
/******************************************************************************/
function ExtractCCAddresses( $cc_email, $username )
{
   global $dbi, $user_prefix;

   // Get the CC Email addresses and generate CC Line
   $cc = "";
   if( $cc_email[ 0 ] != "" )
   {
      for( $i = 0; $i < count( $cc_email ); $i++ )
      {
         // First check if name is a group name	
         $pos = strpos( $cc_email[ $i ], "E-mail Group" );
         if( $pos === false )
         {
            // Normal E-mail address
            $cc_email[ $i ] = substr( $cc_email[ $i ], 0, strpos( $cc_email[ $i ], ">" ) - 1 );
            $cc .= $cc_email[ $i ].",";
         }
         else
         {
            // E-mail Group
            $cc_email[ $i ] = substr( $cc_email[ $i ], 0, strpos( $cc_email[ $i ], ">" ) - 1 );
            // Grep E-mail addresses belonging to this group
            $result = sql_query( "select email, gname from ".$user_prefix."_sitemail_email where uname='$username'", $dbi );
            while( list( $email, $gname ) = sql_fetch_row( $result, $dbi ) )
            {
               $Egname = explode( ",", $gname );
               if( in_array( $cc_email[ $i ], $Egname ) ) { $cc .= $email.","; }
            }
         }
      }

      // $cc = rtrim( $cc, "," );
      // The second parameter was added in PHP 4.1.0. This doesn't work on older PHP versions
      // !! WORKAROUND !!
      $cc = rtrim( $cc );
      $cc = substr( $cc, 0, strlen( $cc ) - 1 ); // returns complete string without last character ','
      return( $cc );
   }
   else
   {
      return( "" );
   }
}

/******************************************************************************/
/* FUNCTION: ExtractBCCAddresses                                              */
/* Get the BCC Email addresses and Generate BCC Line                          */
/******************************************************************************/
function ExtractBCCAddresses( $bcc_email, $username )
{
   global $dbi, $user_prefix;

   // Get the BCC Email addresses and generate BCC Line
   $bcc = "";
   if( $bcc_email[ 0 ] != "" )
   {
      for( $i = 0; $i < count( $bcc_email ); $i++ )
      {
         // First check if name is a group name	
         $pos = strpos( $bcc_email[ $i ], "E-mail Group" );
         if( $pos === false )
         {
            // Normal E-mail address
            $bcc_email[ $i ] = substr( $bcc_email[ $i ], 0, strpos( $bcc_email[ $i ], ">" ) - 1 );
            $bcc .= $bcc_email[ $i ].",";
         }
         else
         {
            // E-mail Group
            $bcc_email[ $i ] = substr( $bcc_email[ $i ], 0, strpos( $bcc_email[ $i ], ">" ) - 1 );
            // Grep E-mail addresses belonging to this group
            $result = sql_query( "select email, gname from ".$user_prefix."_sitemail_email where uname='$username'", $dbi );
            while( list( $email, $gname ) = sql_fetch_row( $result, $dbi ) )
            {
               $Egname = explode( ",", $gname );
               if( in_array( $bcc_email[ $i ], $Egname ) ) { $bcc .= $email.","; }
            }
         }
      }

      // $bcc = rtrim( $bcc, "," );
      // The second parameter was added in PHP 4.1.0. This doesn't work on older PHP versions
      // !! WORKAROUND !!
      $bcc = rtrim( $bcc );
      $bcc = substr( $bcc, 0, strlen( $bcc ) - 1 ); // returns complete string without last character ','
      return( $bcc );
   }
   else
   {
      return( "" );
   }
}

/***************************************************/
/****************** PROGRAM START ******************/
/***************************************************/
switch ( $op )
{
    case "CheckData":
       CheckData( $from_email, $to_email, $cc_email, $bcc_email, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $username );
    break;

    case "SendEmail":
       SendEmail( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $cc_exists, $bcc_exists, $username );
    break;

    case "UpdateUserSettings":
       UpdateUserSettings( $username, $mail_format, $mail_save, $mail_priority, $attachment_sent, $attached_file );
    break;

    case "StoreInSentBox":
       StoreInSentBox( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $username );
    break;

    case "UploadAttachment":
       UploadAttachment( $max_att_size, $upload_dir );
    break;

    case "ExtractTOAddresses":
       ExtractToAddresses( $to_email, $username );
    break;

    case "ExtractCCAddresses":
       ExtractCCAddresses( $cc_email, $username );
    break;

    case "ExtractBCCAddresses":
       ExtractBCCAddresses( $bcc_email, $username );
    break;

    default:
	CheckData( $from_email, $to_email, $cc_email, $bcc_email, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $username );
}


?>