<?php

/************************************************************************************/
/* SiteMail v1.2 for PHP-Nuke 5.6.0                                                 */
/* ================================                                                 */
/*                                                                                  */
/* SiteMail                                                                         */
/* v1.2                                                                             */
/* 02-08-2002                                                                       */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
/* http://mat.allfreetemplates.com                                                  */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

require_once( "mainfile.php" );
global $prefix, $user_prefix, $dbi;

if ( !is_admin( $admin ) )
{
   die ( "Sorry you are not an administrator, You can not install this module" );
}

/******************************************************************************/
/* FUNCTION: UpgradeSiteMail()                                                */
/* Upgrade SiteMail v1.1 to v1.2                                              */
/******************************************************************************/
function UpgradeSiteMail()
{
   global $admin, $user_prefix, $dbi;

   $pagetitle = "SiteMail v1.1 to v1.2 Upgrade";
   include("header.php");
   OpenTable();
   echo "<form action=\"upgrade_sitemail_v1_1_to_v1_2.php\" method=\"post\">\n";
   echo "<center>This script will upgrade your version 1.1 of SiteMail to Version 1.2.<br>\n";
   echo "<br>\n";
   echo "Click \"Upgrade\" below to begin.<br>\n";
   echo "<br>\n";
   echo "<input type=\"hidden\" name=\"op\" value=\"UpgradetoV12\">";
   echo "<input type=\"submit\" value=\"Upgrade\"></center>";
   echo "</form>";
   CloseTable();
   echo "<br>";
   OpenTable();
   echo "<center>$pagetitle by <a href=\"http://mat.allfreetemplates.com\">Maty Scripts</a></center>";
   CloseTable();
   include("footer.php");
}
  
/******************************************************************************/
/* FUNCTION: UpgradetoV12()                                                   */
/* Upgrade SiteMail v1.1 to v1.2                                              */
/******************************************************************************/
function UpgradetoV12()
{
   global $user_prefix, $dbi;

   $pagetitle = "SiteMail v1.1 to v1.2 Upgrade";
   include("header.php");
   
   OpenTable();
   echo "Upgrade Status!<br>\n";
   echo "<br>\n";

   // add 7 new fields in nuke_sitemail_cnf table
   $result = sql_query( "ALTER TABLE $user_prefix"._sitemail_cnf." ADD
   ( 
      from_edit tinyint(1) unsigned NOT NULL default '0',
      mail_method tinyint(1) unsigned NOT NULL default '0',
      allow_attach tinyint(1) unsigned NOT NULL default '0',
      upload_dir varchar(255) NOT NULL default 'uploads/',  
      max_att_size int(11) NOT NULL default '50000',
      smtp_host varchar(25) NOT NULL default 'localhost',
      smtp_port smallint(3) unsigned NOT NULL default '25'
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>Upgrade Error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>Table Upgraded</b>.<br>\n"; }
   echo "<br>\n";

   // add default values to these 7 new fields   
   $result = sql_query( "UPDATE $user_prefix"._sitemail_cnf." SET
   from_edit='0', mail_method='0', allow_attach='0', upload_dir='uploads/', max_att_size='50000', smtp_host='localhost', smtp_port='25', SMVersion='SiteMail v1.2' WHERE uid='1'", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>Insertion error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>Data inserted</b>.<br>\n"; }
   echo "<br>\n";
 
   // add 1 new field in nuke_sitemail_email table
   $result = sql_query( "ALTER TABLE $user_prefix"._sitemail_email." ADD
   (
      gname varchar(255) default NULL
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_email table <b>Upgrade Error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_email table <b>Table Upgraded</b>.<br>\n"; }
   echo "<br>\n";

   // add 2 new fields in nuke_sitemail_users table
   $result = sql_query( "ALTER TABLE $user_prefix"._sitemail_users." ADD
   ( 
      attach_counter int(11) NOT NULL default '0',
      attach_size_counter int(11) NOT NULL default '0'
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_users table <b>Upgrade Error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_users table <b>Table Upgraded</b>.<br>\n"; }
   echo "<br>\n";

   // add default values to these 2 new fields   
   $result = sql_query( "UPDATE $user_prefix"._sitemail_users." SET
   attach_counter='0', attach_size_counter='0'", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_users table <b>Insertion error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_users table <b>Data inserted</b>.<br>\n"; }
   echo "<br>\n";

   // create table nuke_sitemail_emailgroups
   $result = sql_query( "CREATE TABLE $user_prefix"._sitemail_emailgroups."
   ( uid int(11) NOT NULL auto_increment,
     uname varchar(25) NOT NULL default '',
     mailgname varchar(25) NOT NULL default '',
     PRIMARY KEY  (uid)
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_emailgroups table <b>creation error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_emailgroups table <b>created</b>.<br>\n"; }
   echo "<br>\n"; 

   // Optimize SiteMail Tables   
   OptimizeSiteMailTables();
   
   CloseTable();

   echo "<br>";
   OpenTable();
   echo "<center>$pagetitle by <a href=\"http://mat.allfreetemplates.com\">Maty Scripts</a></center>";
   CloseTable();
}

/******************************************************************************/
/* FUNCTION: OptimizeSiteMailTables()                                         */
/* Optimize the 5 SiteMail Tables                                             */
/******************************************************************************/
function OptimizeSiteMailTables()
{
   global $user_prefix, $dbi;
   
   // Optimize SiteMail Tables
   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_cnf."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_email."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_email table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_email table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_sentbox."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_sentbox table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_sentbox table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_users."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_users table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_users table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_emailgroups."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_emailgroups table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_emailgroups table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";     
}

/***************************************************/
/****************** INSTALL START ******************/
/***************************************************/
switch( $op ) 
{
   case "UpgradetoV12":
      UpgradetoV12();
   break;

   case "OptimizeSiteMailTables":
      OptimizeSiteMailTables();
   break;

   default:
      UpgradeSiteMail();
   break;
}

?>
